namespace :attachments do
  desc 'Set mime type where is unknown'
  task set_unknown: :environment do
    LearningObject::Attachment.unknown_mime_type.find_each { |a| BitstreamMimeWorker.perform_async(a.id) }
  end

  desc 'Set default attachment to mp4 version (when video type)'
  task set_videos_to_mp4: :environment do
    LearningObject::Attachment.where(mime_type: 'video/mp4', bundle_name: 'ORIGINAL').includes(:learning_object).find_each do |a|
      a.learning_object.update(attachment: a) if a.learning_object && a.learning_object.attachment != a
    end
  end
end
